/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package se.softstuff.nb.nbtranslate.ide.importw;

import java.util.Set;
import javax.swing.ActionMap;
import org.netbeans.swing.outline.Outline;
import org.openide.explorer.ExplorerManager;
import org.openide.explorer.ExplorerUtils;
import org.openide.explorer.view.OutlineView;
import org.openide.nodes.AbstractNode;
import org.openide.nodes.Children;
import org.openide.nodes.Node;
import org.openide.util.Lookup;
import org.openide.util.NbBundle;
import se.softstuff.nb.nbtranslate.ide.importw.node.ModuleChildFactory;
import se.softstuff.nb.nbtranslate.data.NbTranslation;

/**
 *
 * @author Stefan
 */
public class ImportChoicesPanel extends javax.swing.JPanel implements ExplorerManager.Provider, Lookup.Provider {

    private OutlineView outlineView;
    
    private ExplorerManager explorer;
    
    private Lookup lookup;
        
    private ImportProjectEngine engine;
    
    /**
     * Creates new form ImportChoicesPanel
     */
    public ImportChoicesPanel() {
        
        outlineView = new OutlineView();
        initComponents();
        
        String originName = "origin"; //NOI18N
        String originDisplayName = NbBundle.getMessage(ImportChoicesPanel.class, "ImportChoicesPanel.outlineView.header.origin");//NOI18N
        String exportedName = "exported"; //NOI18N
        String exportedDisplayName = NbBundle.getMessage(ImportChoicesPanel.class, "ImportChoicesPanel.outlineView.header.exported");//NOI18N
        String changedName = "changed"; //NOI18N
        String changedDisplayName = NbBundle.getMessage(ImportChoicesPanel.class, "ImportChoicesPanel.outlineView.header.changed");//NOI18N
        String choice = "choice";
        String choiceDisplayName = NbBundle.getMessage(ImportChoicesPanel.class, "ImportChoicesPanel.outlineView.header.choice");//NOI18N
        String message = "message";
        String messageDisplayName = NbBundle.getMessage(ImportChoicesPanel.class, "ImportChoicesPanel.outlineView.header.message");//NOI18N
        
        outlineView.setPropertyColumns(originName, originDisplayName, exportedName, exportedDisplayName, changedName, changedDisplayName, choice, choiceDisplayName, message, messageDisplayName);

        Outline outline = outlineView.getOutline();
        outline.setRootVisible(false);

        explorer = new ExplorerManager();
        
        ActionMap actionMap = getActionMap();
//        actionMap.put("delete", ExplorerUtils.actionDelete(manager, true)); // NOI18N
        
        lookup = ExplorerUtils.createLookup(explorer, actionMap);
        
        engine = new ImportProjectEngine();
        
    }
    
    void init(NbTranslation translation, Set<String> language) {
               
        ProjectMapper projectMapper = new ProjectMapper();
        projectMapper.fetchOpenProjects();        
        
        engine.start(translation, language, projectMapper, false);
                
        Children kids = Children.create(new ModuleChildFactory(translation, engine), false);

        //Create a root node:
        Node rootNode = new AbstractNode(kids);
        explorer.setRootContext(rootNode);           
    }
    
    @Override
    public ExplorerManager getExplorerManager() {
        return explorer;
    }

    @Override
    public Lookup getLookup() {
        return lookup;
    }
    
    @Override
    public String getName() {
        return NbBundle.getMessage(ImportVisualPanel2.class, "ImportVisualPanel2.bulletin");
    }
    
    ImportProjectEngine getEngine() {
        return engine;
    }
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = outlineView;

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 831, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 450, Short.MAX_VALUE)
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane jScrollPane1;
    // End of variables declaration//GEN-END:variables

    

    
}
